/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the ConnectorTemplateResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConnectorTemplateResponse{}

// ConnectorTemplateResponse struct for ConnectorTemplateResponse
type ConnectorTemplateResponse struct {
	ConnectorId *string                                   `json:"connectorId,omitempty"`
	SourceName  *string                                   `json:"sourceName,omitempty"`
	Categories  []interface{}                             `json:"categories,omitempty"`
	Templates   []ConnectorTemplateResponseTemplatesInner `json:"templates,omitempty"`
	IconUrl     NullableString                            `json:"iconUrl,omitempty"`
}

// NewConnectorTemplateResponse instantiates a new ConnectorTemplateResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConnectorTemplateResponse() *ConnectorTemplateResponse {
	this := ConnectorTemplateResponse{}
	return &this
}

// NewConnectorTemplateResponseWithDefaults instantiates a new ConnectorTemplateResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConnectorTemplateResponseWithDefaults() *ConnectorTemplateResponse {
	this := ConnectorTemplateResponse{}
	return &this
}

// GetConnectorId returns the ConnectorId field value if set, zero value otherwise.
func (o *ConnectorTemplateResponse) GetConnectorId() string {
	if o == nil || IsNil(o.ConnectorId) {
		var ret string
		return ret
	}
	return *o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConnectorTemplateResponse) GetConnectorIdOk() (*string, bool) {
	if o == nil || IsNil(o.ConnectorId) {
		return nil, false
	}
	return o.ConnectorId, true
}

// HasConnectorId returns a boolean if a field has been set.
func (o *ConnectorTemplateResponse) HasConnectorId() bool {
	if o != nil && !IsNil(o.ConnectorId) {
		return true
	}

	return false
}

// SetConnectorId gets a reference to the given string and assigns it to the ConnectorId field.
func (o *ConnectorTemplateResponse) SetConnectorId(v string) {
	o.ConnectorId = &v
}

// GetSourceName returns the SourceName field value if set, zero value otherwise.
func (o *ConnectorTemplateResponse) GetSourceName() string {
	if o == nil || IsNil(o.SourceName) {
		var ret string
		return ret
	}
	return *o.SourceName
}

// GetSourceNameOk returns a tuple with the SourceName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConnectorTemplateResponse) GetSourceNameOk() (*string, bool) {
	if o == nil || IsNil(o.SourceName) {
		return nil, false
	}
	return o.SourceName, true
}

// HasSourceName returns a boolean if a field has been set.
func (o *ConnectorTemplateResponse) HasSourceName() bool {
	if o != nil && !IsNil(o.SourceName) {
		return true
	}

	return false
}

// SetSourceName gets a reference to the given string and assigns it to the SourceName field.
func (o *ConnectorTemplateResponse) SetSourceName(v string) {
	o.SourceName = &v
}

// GetCategories returns the Categories field value if set, zero value otherwise.
func (o *ConnectorTemplateResponse) GetCategories() []interface{} {
	if o == nil || IsNil(o.Categories) {
		var ret []interface{}
		return ret
	}
	return o.Categories
}

// GetCategoriesOk returns a tuple with the Categories field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConnectorTemplateResponse) GetCategoriesOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Categories) {
		return nil, false
	}
	return o.Categories, true
}

// HasCategories returns a boolean if a field has been set.
func (o *ConnectorTemplateResponse) HasCategories() bool {
	if o != nil && !IsNil(o.Categories) {
		return true
	}

	return false
}

// SetCategories gets a reference to the given []interface{} and assigns it to the Categories field.
func (o *ConnectorTemplateResponse) SetCategories(v []interface{}) {
	o.Categories = v
}

// GetTemplates returns the Templates field value if set, zero value otherwise.
func (o *ConnectorTemplateResponse) GetTemplates() []ConnectorTemplateResponseTemplatesInner {
	if o == nil || IsNil(o.Templates) {
		var ret []ConnectorTemplateResponseTemplatesInner
		return ret
	}
	return o.Templates
}

// GetTemplatesOk returns a tuple with the Templates field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConnectorTemplateResponse) GetTemplatesOk() ([]ConnectorTemplateResponseTemplatesInner, bool) {
	if o == nil || IsNil(o.Templates) {
		return nil, false
	}
	return o.Templates, true
}

// HasTemplates returns a boolean if a field has been set.
func (o *ConnectorTemplateResponse) HasTemplates() bool {
	if o != nil && !IsNil(o.Templates) {
		return true
	}

	return false
}

// SetTemplates gets a reference to the given []ConnectorTemplateResponseTemplatesInner and assigns it to the Templates field.
func (o *ConnectorTemplateResponse) SetTemplates(v []ConnectorTemplateResponseTemplatesInner) {
	o.Templates = v
}

// GetIconUrl returns the IconUrl field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ConnectorTemplateResponse) GetIconUrl() string {
	if o == nil || IsNil(o.IconUrl.Get()) {
		var ret string
		return ret
	}
	return *o.IconUrl.Get()
}

// GetIconUrlOk returns a tuple with the IconUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ConnectorTemplateResponse) GetIconUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.IconUrl.Get(), o.IconUrl.IsSet()
}

// HasIconUrl returns a boolean if a field has been set.
func (o *ConnectorTemplateResponse) HasIconUrl() bool {
	if o != nil && o.IconUrl.IsSet() {
		return true
	}

	return false
}

// SetIconUrl gets a reference to the given NullableString and assigns it to the IconUrl field.
func (o *ConnectorTemplateResponse) SetIconUrl(v string) {
	o.IconUrl.Set(&v)
}

// SetIconUrlNil sets the value for IconUrl to be an explicit nil
func (o *ConnectorTemplateResponse) SetIconUrlNil() {
	o.IconUrl.Set(nil)
}

// UnsetIconUrl ensures that no value is present for IconUrl, not even an explicit nil
func (o *ConnectorTemplateResponse) UnsetIconUrl() {
	o.IconUrl.Unset()
}

func (o ConnectorTemplateResponse) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConnectorTemplateResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ConnectorId) {
		toSerialize["connectorId"] = o.ConnectorId
	}
	if !IsNil(o.SourceName) {
		toSerialize["sourceName"] = o.SourceName
	}
	if !IsNil(o.Categories) {
		toSerialize["categories"] = o.Categories
	}
	if !IsNil(o.Templates) {
		toSerialize["templates"] = o.Templates
	}
	if o.IconUrl.IsSet() {
		toSerialize["iconUrl"] = o.IconUrl.Get()
	}
	return toSerialize, nil
}

type NullableConnectorTemplateResponse struct {
	value *ConnectorTemplateResponse
	isSet bool
}

func (v NullableConnectorTemplateResponse) Get() *ConnectorTemplateResponse {
	return v.value
}

func (v *NullableConnectorTemplateResponse) Set(val *ConnectorTemplateResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableConnectorTemplateResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableConnectorTemplateResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConnectorTemplateResponse(val *ConnectorTemplateResponse) *NullableConnectorTemplateResponse {
	return &NullableConnectorTemplateResponse{value: val, isSet: true}
}

func (v NullableConnectorTemplateResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConnectorTemplateResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
